// string in, string out. eval() is not allowed.
function my_eval(x) {
	return x;
}

// try to nicely round number
function abbrNum(n, decPlaces) {
	if (n == 0) {
		return n;
	}
	decPlaces -= Math.floor(Math.log(Math.abs(n)) / Math.log(10)) + 1;
	f = Math.pow(10, decPlaces);
	return Math.round(n * f) / f;
}

function set_cookie(t) {
	// set cookie with the active field
	var expires = new Date();
	expires.setTime(expires.getTime() + 30*24*60*60*1000);
	expires = ";expires=" + expires.toGMTString();
	document.cookie = "form=" + t.form.name + expires;
	document.cookie = "input=" + t.name + expires;
	document.cookie = "val=" + t.value + expires;
}

function calc(t) {
	set_cookie(t);

	// normalize value
	var val = parseFloat(my_eval(t.value)) / parseFloat(t.defaultValue);
	
	// update all form values (except self)
	var elements = t.form.elements;
	for (i = 0; i < elements.length; ++i) {
		var elem = elements[i];
		if (elem != t) {
			var x = val * parseFloat(elem.defaultValue);
			if (x == 0) {
				elem.value = 0;
			} else {
				elem.value = abbrNum(x, 3);
			}
		}
	}
}

function calc_c_to_f(t) {
	set_cookie(t);
	document.temperature.F.value = abbrNum(1.8 * parseFloat(my_eval(t.value)) + 32, 3);
}

function calc_f_to_c(t) {
	set_cookie(t);
	document.temperature.C.value = abbrNum((parseFloat(my_eval(t.value)) - 32) / 1.8, 3);
}


window.onload = function() {
	// load get cookie, if present
	var dict = new Array();
	if (document.cookie) {
		fields = document.cookie.split("; ");
		
		for (i=0; i<fields.length; ++i) {
			idx = fields[i].indexOf("=");
			key = fields[i].substr(0, idx);
			val = fields[i].substr(idx+1);
			dict[key] = val;
		}
	}
	calc(document.weight.kg);
	calc(document.volume.l);
	calc_c_to_f(document.temperature.C);
	
	// when we had a cookie, try to activate the last field
	if (dict["form"] && dict["input"] && dict["val"]) {
		elem = document.getElementsByName(dict["form"])[0];
		elem = elem[dict["input"]];
		elem.focus();
		elem.value = dict["val"];
		elem.select();
		if (dict["form"] == "temperature") {
			if (dict["input"] == "C") {
				calc_c_to_f(elem);
			} else {
				calc_f_to_c(elem);
			}
		} else {
			calc(elem);
		}
	}
}

function click_handler(e) {
	e.target.select();
}
function calc_handler(e) {
	calc(e.target);
}
function calc_c_to_f_handler(e) {
	calc_c_to_f(e.target);
}
function calc_f_to_c_handler(e) {
	calc_f_to_c(e.target);
}

// Add event listeners once the DOM has fully loaded by listening for the
// `DOMContentLoaded` event on the document, and adding your listeners to
// specific elements when it triggers.
document.addEventListener('DOMContentLoaded', function () {
	// handle click
	var inputs = document.getElementsByTagName('input');
	for (i=0; i<inputs.length; ++i) {
		inputs[i].addEventListener('click', click_handler);
	}
	
	// handle keyup
	elem = document.getElementsByName("temperature")[0];
	elem["C"].addEventListener('keyup', calc_c_to_f_handler);
	elem["F"].addEventListener('keyup', calc_f_to_c_handler);
	
	elem = document.getElementsByName("weight")[0];
	for (i=0; i<elem.length; ++i) {
		elem[i].addEventListener('keyup', calc_handler);
	}
	
	elem = document.getElementsByName("volume")[0];
	for (i=0; i<elem.length; ++i) {
		elem[i].addEventListener('keyup', calc_handler);
	}
	
	elem = document.getElementById("h_fblike");
	elem.src  = 'http://www.facebook.com/plugins/like.php?href=https%3A%2F%2Fchrome.google.com%2Fwebstore%2Fdetail%2Fcpmajpjgghbgnplkodkmapnlkapkgbog&send=false&layout=button_count&width=120&show_faces=false&action=like&colorscheme=light&font&height=21&appId=167395356625465';
});

